
/////////////////////////////////////////////////////////////////////
// Mapper 13
void NES_mapper13::Reset()
{
  // set CPU bank pointers
  set_CPU_banks(0,1,2,3);

  // set PPU bank pointers
  parent_NES->ppu->PPU_VRAM_banks[0] = chr_ram + 0x400 * 0;
  parent_NES->ppu->PPU_VRAM_banks[1] = chr_ram + 0x400 * 1;
  parent_NES->ppu->PPU_VRAM_banks[2] = chr_ram + 0x400 * 2;
  parent_NES->ppu->PPU_VRAM_banks[3] = chr_ram + 0x400 * 3;
  parent_NES->ppu->PPU_VRAM_banks[4] = chr_ram + 0x400 * 0;
  parent_NES->ppu->PPU_VRAM_banks[5] = chr_ram + 0x400 * 1;
  parent_NES->ppu->PPU_VRAM_banks[6] = chr_ram + 0x400 * 2;
  parent_NES->ppu->PPU_VRAM_banks[7] = chr_ram + 0x400 * 3;
}

void NES_mapper13::MemoryWrite(uint32 addr, uint8 data)
{
  uint8 prg_bank = (data & 0x30) >> 4;
  uint8 chr_bank = data & 0x03;

  set_CPU_bank4(prg_bank*4+0);
  set_CPU_bank5(prg_bank*4+1);
  set_CPU_bank6(prg_bank*4+2);
  set_CPU_bank7(prg_bank*4+3);

  parent_NES->ppu->PPU_VRAM_banks[4] = chr_ram + 0x400 * (chr_bank*4+0);
  parent_NES->ppu->PPU_VRAM_banks[5] = chr_ram + 0x400 * (chr_bank*4+1);
  parent_NES->ppu->PPU_VRAM_banks[6] = chr_ram + 0x400 * (chr_bank*4+2);
  parent_NES->ppu->PPU_VRAM_banks[7] = chr_ram + 0x400 * (chr_bank*4+3);
}

/////////////////////////////////////////////////////////////////////

