
/////////////////////////////////////////////////////////////////////
// Mapper 96
void NES_mapper96::Reset()
{
  // set CPU bank pointers
  set_CPU_banks(0,1,2,3);

  // set PPU bank pointers
  vbank0 = vbank1 = 0;
  sync_PPU_banks();

  set_mirroring(0,0,0,0);
}

void NES_mapper96::PPU_Latch_Address(uint32 addr)
{
  if((addr & 0xF000) == 0x2000)
  {
    vbank1 = (addr & 0x0300) >> 8;
    sync_PPU_banks();
  }
}

void NES_mapper96::MemoryWrite(uint32 addr, uint8 data)
{
  set_CPU_bank4((data & 0x03) * 4 + 0);
  set_CPU_bank5((data & 0x03) * 4 + 1);
  set_CPU_bank6((data & 0x03) * 4 + 2);
  set_CPU_bank7((data & 0x03) * 4 + 3);

  vbank0 = (data & 0x04) >> 2;
  sync_PPU_banks();
}

void NES_mapper96::sync_PPU_banks()
{
  parent_NES->ppu->PPU_VRAM_banks[0] = vram + vbank0 * 0x4000 + vbank1 * 0x1000 + 0x000;
  parent_NES->ppu->PPU_VRAM_banks[1] = vram + vbank0 * 0x4000 + vbank1 * 0x1000 + 0x400;
  parent_NES->ppu->PPU_VRAM_banks[2] = vram + vbank0 * 0x4000 + vbank1 * 0x1000 + 0x800;
  parent_NES->ppu->PPU_VRAM_banks[3] = vram + vbank0 * 0x4000 + vbank1 * 0x1000 + 0xC00;
  parent_NES->ppu->PPU_VRAM_banks[4] = vram + vbank0 * 0x4000 + 0x3000;
  parent_NES->ppu->PPU_VRAM_banks[5] = vram + vbank0 * 0x4000 + 0x3400;
  parent_NES->ppu->PPU_VRAM_banks[6] = vram + vbank0 * 0x4000 + 0x3800;
  parent_NES->ppu->PPU_VRAM_banks[7] = vram + vbank0 * 0x4000 + 0x3C00;
}
/////////////////////////////////////////////////////////////////////

