
/////////////////////////////////////////////////////////////////////
// Mapper 232
void NES_mapper232::Reset()
{
  // set CPU bank pointers
  set_CPU_banks(0,1,num_8k_ROM_banks-2,num_8k_ROM_banks-1);

  prg_bank0 = 0x0C;
  prg_bank1 = 0x00;
}

void NES_mapper232::MemoryWrite(uint32 addr, uint8 data)
{
  if(addr == 0x9000)
  {
    prg_bank0 = (data & 0x18) >> 1;
  }
  else if(0xA000 <= addr && addr <= 0xFFFF)
  {
    prg_bank1 = data & 0x03;
  }
  uint8 prg0 = prg_bank0 | prg_bank1;
  uint8 prg1 = prg_bank0 | 0x03;

  set_CPU_bank4(prg0*2+0);
  set_CPU_bank5(prg0*2+1);
  set_CPU_bank6(prg1*2+0);
  set_CPU_bank7(prg1*2+1);
}
/////////////////////////////////////////////////////////////////////

